gitweb: Fix split patches output (e.g. file to symlink)
[git/dscho.git] / git-rebase.sh
blob828c59ce61a8317f23ba9113e4de6e09a58e70ce
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano.
6 USAGE='[-v] [--onto <newbase>] <upstream> [<branch>]'
7 LONG_USAGE='git-rebase replaces <branch> with a new branch of the
8 same name. When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
13 It is possible that a merge failure will prevent this process from being
14 completely automatic. You will have to resolve any such merge failure
15 and run git rebase --continue. Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip. To restore the
17 original <branch> and remove the .dotest working files, use the command
18 git rebase --abort instead.
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used. You must be in the top
22 directory of your project to start (or continue) a rebase.
24 Example: git-rebase master~1 topic
26 A---B---C topic A'\''--B'\''--C'\'' topic
27 / --> /
28 D---E---F---G master D---E---F---G master
30 . git-sh-setup
31 set_reflog_action rebase
33 RESOLVEMSG="
34 When you have resolved this problem run \"git rebase --continue\".
35 If you would prefer to skip this patch, instead run \"git rebase --skip\".
36 To restore the original branch and stop rebasing run \"git rebase --abort\".
38 unset newbase
39 strategy=recursive
40 do_merge=
41 dotest=$GIT_DIR/.dotest-merge
42 prec=4
43 verbose=
45 continue_merge () {
46 test -n "$prev_head" || die "prev_head must be defined"
47 test -d "$dotest" || die "$dotest directory does not exist"
49 unmerged=$(git-ls-files -u)
50 if test -n "$unmerged"
51 then
52 echo "You still have unmerged paths in your index"
53 echo "did you forget update-index?"
54 die "$RESOLVEMSG"
57 if test -n "`git-diff-index HEAD`"
58 then
59 if ! git-commit -C "`cat $dotest/current`"
60 then
61 echo "Commit failed, please do not call \"git commit\""
62 echo "directly, but instead do one of the following: "
63 die "$RESOLVEMSG"
65 printf "Committed: %0${prec}d" $msgnum
66 else
67 printf "Already applied: %0${prec}d" $msgnum
69 echo ' '`git-rev-list --pretty=oneline -1 HEAD | \
70 sed 's/^[a-f0-9]\+ //'`
72 prev_head=`git-rev-parse HEAD^0`
73 # save the resulting commit so we can read-tree on it later
74 echo "$prev_head" > "$dotest/prev_head"
76 # onto the next patch:
77 msgnum=$(($msgnum + 1))
78 echo "$msgnum" >"$dotest/msgnum"
81 call_merge () {
82 cmt="$(cat $dotest/cmt.$1)"
83 echo "$cmt" > "$dotest/current"
84 hd=$(git-rev-parse --verify HEAD)
85 cmt_name=$(git-symbolic-ref HEAD)
86 msgnum=$(cat $dotest/msgnum)
87 end=$(cat $dotest/end)
88 eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
89 eval GITHEAD_$hd='"$(cat $dotest/onto_name)"'
90 export GITHEAD_$cmt GITHEAD_$hd
91 git-merge-$strategy "$cmt^" -- "$hd" "$cmt"
92 rv=$?
93 case "$rv" in
95 unset GITHEAD_$cmt GITHEAD_$hd
96 return
99 test -d "$GIT_DIR/rr-cache" && git-rerere
100 die "$RESOLVEMSG"
103 echo "Strategy: $rv $strategy failed, try another" 1>&2
104 die "$RESOLVEMSG"
107 die "Unknown exit code ($rv) from command:" \
108 "git-merge-$strategy $cmt^ -- HEAD $cmt"
110 esac
113 finish_rb_merge () {
114 rm -r "$dotest"
115 echo "All done."
118 while case "$#" in 0) break ;; esac
120 case "$1" in
121 --continue)
122 diff=$(git-diff-files)
123 case "$diff" in
124 ?*) echo "You must edit all merge conflicts and then"
125 echo "mark them as resolved using git update-index"
126 exit 1
128 esac
129 if test -d "$dotest"
130 then
131 prev_head="`cat $dotest/prev_head`"
132 end="`cat $dotest/end`"
133 msgnum="`cat $dotest/msgnum`"
134 onto="`cat $dotest/onto`"
135 continue_merge
136 while test "$msgnum" -le "$end"
138 call_merge "$msgnum"
139 continue_merge
140 done
141 finish_rb_merge
142 exit
144 git am --resolved --3way --resolvemsg="$RESOLVEMSG"
145 exit
147 --skip)
148 if test -d "$dotest"
149 then
150 if test -d "$GIT_DIR/rr-cache"
151 then
152 git-rerere clear
154 prev_head="`cat $dotest/prev_head`"
155 end="`cat $dotest/end`"
156 msgnum="`cat $dotest/msgnum`"
157 msgnum=$(($msgnum + 1))
158 onto="`cat $dotest/onto`"
159 while test "$msgnum" -le "$end"
161 call_merge "$msgnum"
162 continue_merge
163 done
164 finish_rb_merge
165 exit
167 git am -3 --skip --resolvemsg="$RESOLVEMSG"
168 exit
170 --abort)
171 if test -d "$GIT_DIR/rr-cache"
172 then
173 git-rerere clear
175 if test -d "$dotest"
176 then
177 rm -r "$dotest"
178 elif test -d .dotest
179 then
180 rm -r .dotest
181 else
182 die "No rebase in progress?"
184 git reset --hard ORIG_HEAD
185 exit
187 --onto)
188 test 2 -le "$#" || usage
189 newbase="$2"
190 shift
192 -M|-m|--m|--me|--mer|--merg|--merge)
193 do_merge=t
195 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
196 --strateg=*|--strategy=*|\
197 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
198 case "$#,$1" in
199 *,*=*)
200 strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
201 1,*)
202 usage ;;
204 strategy="$2"
205 shift ;;
206 esac
207 do_merge=t
209 -v|--verbose)
210 verbose=t
213 usage
216 break
218 esac
219 shift
220 done
222 # Make sure we do not have .dotest
223 if test -z "$do_merge"
224 then
225 if mkdir .dotest
226 then
227 rmdir .dotest
228 else
229 echo >&2 '
230 It seems that I cannot create a .dotest directory, and I wonder if you
231 are in the middle of patch application or another rebase. If that is not
232 the case, please rm -fr .dotest and run me again. I am stopping in case
233 you still have something valuable there.'
234 exit 1
236 else
237 if test -d "$dotest"
238 then
239 die "previous dotest directory $dotest still exists." \
240 'try git-rebase < --continue | --abort >'
244 # The tree must be really really clean.
245 git-update-index --refresh || exit
246 diff=$(git-diff-index --cached --name-status -r HEAD)
247 case "$diff" in
248 ?*) echo "$diff"
249 exit 1
251 esac
253 # The upstream head must be given. Make sure it is valid.
254 upstream_name="$1"
255 upstream=`git rev-parse --verify "${upstream_name}^0"` ||
256 die "invalid upstream $upstream_name"
258 # If a hook exists, give it a chance to interrupt
259 if test -x "$GIT_DIR/hooks/pre-rebase"
260 then
261 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
262 echo >&2 "The pre-rebase hook refused to rebase."
263 exit 1
267 # If the branch to rebase is given, first switch to it.
268 case "$#" in
270 branch_name="$2"
271 git-checkout "$2" || usage
274 branch_name=`git symbolic-ref HEAD` || die "No current branch"
275 branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
277 esac
278 branch=$(git-rev-parse --verify "${branch_name}^0") || exit
280 # Make sure the branch to rebase onto is valid.
281 onto_name=${newbase-"$upstream_name"}
282 onto=$(git-rev-parse --verify "${onto_name}^0") || exit
284 # Now we are rebasing commits $upstream..$branch on top of $onto
286 # Check if we are already based on $onto, but this should be
287 # done only when upstream and onto are the same.
288 mb=$(git-merge-base "$onto" "$branch")
289 if test "$upstream" = "$onto" && test "$mb" = "$onto"
290 then
291 echo >&2 "Current branch $branch_name is up to date."
292 exit 0
295 if test -n "$verbose"
296 then
297 echo "Changes from $mb to $onto:"
298 git-diff-tree --stat --summary "$mb" "$onto"
301 # Rewind the head to "$onto"; this saves our current head in ORIG_HEAD.
302 echo "First, rewinding head to replay your work on top of it..."
303 git-reset --hard "$onto"
305 # If the $onto is a proper descendant of the tip of the branch, then
306 # we just fast forwarded.
307 if test "$mb" = "$branch"
308 then
309 echo >&2 "Fast-forwarded $branch_name to $onto_name."
310 exit 0
313 if test -z "$do_merge"
314 then
315 git-format-patch -k --stdout --full-index --ignore-if-in-upstream "$upstream"..ORIG_HEAD |
316 git am --binary -3 -k --resolvemsg="$RESOLVEMSG"
317 exit $?
320 # start doing a rebase with git-merge
321 # this is rename-aware if the recursive (default) strategy is used
323 mkdir -p "$dotest"
324 echo "$onto" > "$dotest/onto"
325 echo "$onto_name" > "$dotest/onto_name"
326 prev_head=`git-rev-parse HEAD^0`
327 echo "$prev_head" > "$dotest/prev_head"
329 msgnum=0
330 for cmt in `git-rev-list --no-merges "$upstream"..ORIG_HEAD \
331 | @@PERL@@ -e 'print reverse <>'`
333 msgnum=$(($msgnum + 1))
334 echo "$cmt" > "$dotest/cmt.$msgnum"
335 done
337 echo 1 >"$dotest/msgnum"
338 echo $msgnum >"$dotest/end"
340 end=$msgnum
341 msgnum=1
343 while test "$msgnum" -le "$end"
345 call_merge "$msgnum"
346 continue_merge
347 done
349 finish_rb_merge